/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
// derived from com.ibm.team.apt.web.client.internal.PlanExtensionRegistry
dojo.provide("com.ibm.team.workitem.web.client.internal.WorkItemExtensionRegistry"); //$NON-NLS-1$

dojo.require("jazz.core.RegistryFactory"); //$NON-NLS-1$

(function() { // module container

var RegistryFactory 	= jazz.core.RegistryFactory;
var KEY = "com.ibm.team.workitem.web.editorToolbarAction"; //"com_ibm_team_workitem_web_editorToolbarAction";//$NON-NLS-1$ 

com.ibm.team.workitem.web.client.internal.WorkItemExtensionRegistry= {
	
	// ---- API ------------------------------------------------------------------------------------------------------------	
	
	getContributedEditorToolbarActions: function() {
		if (this._contributedEditorToolBarActions == null) {
			this._loadContributedEditorToolBarActions();
		}
		return this._contributedEditorToolBarActions;
	},

	// ---- implementation -------------------------------------------------------------------------------------------------

	_contributedEditorToolBarActions: null,

	_loadContributedEditorToolBarActions: function() {
		var extensionPoint= RegistryFactory.getRegistry().getExtensionPoint(KEY);; // getExtensionPoints()
		var contributedActions= [];
		if(extensionPoint) {
			dojo.forEach(extensionPoint.getExtensions(), function(extension) {
				dojo.forEach(extension.getConfigurationElements(), function(configElement) {
					contributedActions.push({
						action: configElement.getAttribute("action"), //$NON-NLS-1$
						alt: configElement.getAttribute("alt"), //$NON-NLS-1$
						iconContext: configElement.getAttribute("iconContext"), //$NON-NLS-1$
						iconUri: configElement.getAttribute("iconUri"), //$NON-NLS-1$
						id: configElement.getAttribute("id"), //$NON-NLS-1$
						label: configElement.getAttribute("label"), //$NON-NLS-1$
						parameter: configElement.getAttribute("parameter") //$NON-NLS-1$
					});
				});
			});
		}
		this._contributedEditorToolBarActions= contributedActions;
	}
};

})();