/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.build.web.ui.BuildConstants");

(function() {

/*
 * Build web ui constants.
 */
com.ibm.team.build.web.ui.BuildConstants = {

	/*
	 * Page action for the build web ui entry point.
	 */
	ACTION_VIEW_DEFAULT: "com.ibm.team.build.viewDefault",
	
	/*
	 * Page action for viewing definitions for a project area.
	 */
	ACTION_VIEW_DEFINITION_LIST: "com.ibm.team.build.viewDefinitionList",
	
	/*
	 * Page action for viewing details about a build definition.
	 */
	ACTION_VIEW_DEFINITION: "com.ibm.team.build.viewDefinition",
	
	/*
	 * Page action for viewing a build result.
	 */
	ACTION_VIEW_RESULT: "com.ibm.team.build.viewResult",

	/*
	 * Page action for viewing the build queue.
	 */
	ACTION_VIEW_BUILD_QUEUE: "com.ibm.team.build.viewBuildQueue",

	/*
	 * Page action for requesting a build.
	 */
	ACTION_REQUEST_BUILD: "com.ibm.team.build.requestBuild",

	/*
	 * Page action for viewing the build engines.
	 */
	
	ACTION_VIEW_BUILD_ENGINES: "com.ibm.team.build.viewBuildEngines",

	/*
	 * Page id of build.
	 */
	PAGE_ID: "com.ibm.team.build",
	
	/*
	 * Build URL parameter for specifying a team area name/path.
	 */	
	URL_PARAM_TEAM: "team",

	/*
	 * Build URL parameter for specifying a project name.
	 */	
	URL_PARAM_PROJECT: "project",

	/*
	 * Build URL parameter for specifying a unique id.
	 */	
	URL_PARAM_ID: "id",

	/*
	 * Build URL parameter for specifying a build definition.
	 */	
	URL_PARAM_DEFINITION: "definition",

	/*
	 * Build URL parameter for specifying a build result.
	 */	
	URL_PARAM_RESULT: "result",

	/*
	 * Build URL parameter for specifying a specific tab.
	 */	
	URL_PARAM_TAB: "tab",
	
	/*
	 * Identifier of the overview tab of the build result page.
	 */
	RESULT_TAB_OVERVIEW: "overview",
	
	/*
	 * Identifier of the compilation tab of the build result page.
	 */
	RESULT_TAB_COMPILATION: "compilation",
	/*
	 * Identifier of the junit tab of the build result page.
	 */
	RESULT_TAB_JUNIT: "junit",
	
	/*
	 * Identifier of the downloads tab of the build result page.
	 */
	RESULT_TAB_DOWNLOADS: "downloads",
	
	/*
	 * Identifier of the logs tab of the build result page.
	 */
	RESULT_TAB_LOGS: "logs",
	
	/*
	 * Identifier of the external links tab of the build result page.
	 */
	RESULT_TAB_LINKS: "links",
	
	/*
	 * Identifier of the work items tab of the build result page.
	 */
	RESULT_TAB_WORKITEMS: "workItems"
};

})();
