/*
 * Licensed Materials - Property of IBM
 * Rational ClearQuest 
 * (C) Copyright IBM Corp. 2009  All Rights Reserved
 * US Government Users Restricted Rights -
 * Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp
 */

/*
 * Viewlet that requires authentication from ClearQuest
 * It shows main content if authenticated
 */
dojo.provide("com.ibm.rational.cm.web.viewlets.ui.Viewlet");

dojo.require("dojo.i18n");
dojo.require("com.ibm.team.dashboard.web.ui.Viewlet");

dojo.requireLocalization("com.ibm.rational.cm.web.viewlets.ui", "ViewletMessages");

dojo.declare(
	"com.ibm.rational.cm.web.viewlets.ui.Viewlet",
	com.ibm.team.dashboard.web.ui.Viewlet,
{
	templateString: '<div><div dojoAttachPoint="mainContent"></div><div dojoAttachPoint="loginContent" style="padding:3px;"><div>${messages.NeedLogin}</div><div><a href="javascript:void(0);" dojoAttachEvent="onclick:load"><span class="dijitInline cqLoginIcon"></span> ${messages.Login}</a></div></div></div>',

	constructor: function(){
		this.messages = dojo.i18n.getLocalization("com.ibm.rational.cm.web.viewlets.ui", "ViewletMessages");
	},
	
	/*
	 * Called when login link is clicked
	 */
	load: function(){},
	
	showMainContent: function(/* boolean */ authenticated){
		this.mainContent.style.display = (authenticated) ? "" : "none";
		this.loginContent.style.display = (!authenticated) ? "" : "none";
		
		var msg = (authenticated) ? "" : "("+this.messages.NotLoggedIn+")";
		this.getSite().setSecondaryTitle(msg);
	}
});