/*
 * Licensed Materials - Property of IBM
 * Rational ClearQuest 
 * (C) Copyright IBM Corp. 2009  All Rights Reserved
 * US Government Users Restricted Rights -
 * Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp
 */

dojo.provide("com.ibm.rational.cm.web.ui.ajaxModules.NavigatorModule");

dojo.require("dojo.i18n");
dojo.require("com.ibm.rational.cm.web.ui.ajaxModules.AjaxModuleWrapper");

dojo.requireLocalization("com.ibm.rational.cm.web.ui", "common");

(function(){

dojo.declare(
	"com.ibm.rational.cm.web.ui.ajaxModules.NavigatorModule",
	com.ibm.rational.cm.web.ui.ajaxModules.AjaxModuleWrapper,
{
	widgetClass: "com.ibm.rational.cm.web.ui.view.common.Tree",
	
	postCreate: function(){
		var messages = dojo.i18n.getLocalization("com.ibm.rational.cm.web.ui", "common");

		// create navigtor tree
		dojo["require"]("com.ibm.rational.cm.web.ui.view.navigation.NavigatorModel");
		this.props = com.ibm.rational.cm.getNavigatorProperties();
		
		this.inherited(arguments);
		
		this.widget.onClick = dojo.hitch(this, "onTreeNodeClick");
		
		// add OK/Cancel button
		var okBtn = dojo.doc.createElement("BUTTON");
		okBtn.innerHTML = messages.lblOk;
		this.connect(okBtn, "onclick", "onOk");
		this.domNode.appendChild(okBtn);
		var cancelBtn = dojo.doc.createElement("BUTTON");
		cancelBtn.innerHTML = messages.lblCancel;
		this.connect(cancelBtn, "onclick", "onCancel");
		this.domNode.appendChild(cancelBtn);
	},
	
	// summary: user overridable function for executing a tree item
	onTreeNodeClick: function(/* dojo.data */ item, /*TreeNode*/ node){
		var model = this.widget.model;
		console.debug("Tree node clicked: label="+model.getLabel(item)+", stableLocation="+model.getIdentity(item));
	},
	
	onOk: function(e){
		var tree = this.widget;
		var selected = dojo.map(tree.getSelection(), function(treeNode){
			return tree.model.getLabel(treeNode.item);
		});
		alert("OK button clicked. Selected node is:\n"+selected);
	},
	
	onCancel: function(e){
		alert("Cancel button clicked");
	}
});

})();
