/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.dashboard.web.ui.internal.AllDashboards");

dojo.require("dojo.i18n");

dojo.require("com.ibm.team.dashboard.web.client.internal.DashboardClient");
dojo.require("com.ibm.team.dashboard.web.ui.internal.Constants");
dojo.require("com.ibm.team.dashboard.web.util.internal.Util");
dojo.require("com.ibm.team.dashboard.web.ui.internal.AllTeamAreas");
dojo.require("com.ibm.team.dashboard.web.ui.internal.AllShared");
dojo.require("com.ibm.team.dashboard.web.ui.DashboardConstants");
dojo.require("com.ibm.team.dashboard.web.ui.internal.Constants");

dojo.requireLocalization("com.ibm.team.dashboard.web.ui.internal", "DashboardMessages");

(function() {

//
// Aliases
//
var Constants = com.ibm.team.dashboard.web.ui.internal.Constants;
var DashboardClient = com.ibm.team.dashboard.web.client.internal.DashboardClient;
var Util = com.ibm.team.dashboard.web.util.internal.Util;
var AllTeamAreas = com.ibm.team.dashboard.web.ui.internal.AllTeamAreas;
var AllUsers = com.ibm.team.dashboard.web.ui.internal.AllUsers;
var AllShared = com.ibm.team.dashboard.web.ui.internal.AllShared;
var DashboardConstants = com.ibm.team.dashboard.web.ui.DashboardConstants;
var Constants = com.ibm.team.dashboard.web.ui.internal.Constants;

/**
 * The widget for the content area (right side) of the dashboard.
 */
dojo.declare("com.ibm.team.dashboard.web.ui.internal.AllDashboards",
	[dijit._Widget, dijit._Templated], {
	
	templatePath: dojo.moduleUrl("com.ibm.team.dashboard.web", "ui/internal/templates/AllDashboards.html"),
	
	constructor: function() {
		// messages only used in constructor, don't hold reference
		var messages = dojo.i18n.getLocalization("com.ibm.team.dashboard.web.ui.internal", "DashboardMessages");
		this.allHeading = messages.allHeading;
		this.allTeams = messages.allTeams;
		this.allShared = messages.allShared;
	},
	init: function() {
		this._tabWrapper.style.display = "block";
		this._allTeamsLink.href = Util.getAllDashboardsHref();
		this._allSharedLink.href = Util.getAllDashboardsHref(1);
		this._update();
	},
	select: function(tab) {
		this.tab = tab;
		this._update();
	},
	_update: function() {
		if (this.tab && this.tab == 1)
			this._selectAllSharedTab();
		else {
			this._selectAllTeamAreasTab();
		}
	},
	_selectAllTeamAreasTab: function() {
		dojo.addClass(this._allTeamAreasTab,"selectedTab");
		dojo.removeClass(this._allSharedTab,"selectedTab");
		this._updateContentArea(0);
	},
	_selectAllSharedTab: function() {
		dojo.addClass(this._allSharedTab,"selectedTab");
		dojo.removeClass(this._allTeamAreasTab,"selectedTab");
		this._updateContentArea(1);		
	},
	_updateContentArea: function(tab) {
		if (tab == 0) {
			if (!this._allTeamAreasWidget) 
				this._allTeamAreasWidget = new AllTeamAreas({
					dashboardPage: this
				});
			var node = this._allTeamAreasWidget.domNode;
		} else {
			if (!this._allSharedWidget)
				this._allSharedWidget = new AllShared({
					dashboardPage: this
				});
			var node = this._allSharedWidget.domNode;
		}
		if (this._contentArea.firstChild)
			this._contentArea.replaceChild(node, this._contentArea.firstChild);
		else
			this._contentArea.appendChild(node);
	}
});
})();
