/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2008. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.reports.web.ui.internal.ReportTemplateEditor");

dojo.require("dojo.i18n");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");

dojo.require("com.ibm.team.reports.web.ui.internal.ListBox");
dojo.require("com.ibm.team.reports.web.client.internal.ReportsClient");

dojo.requireLocalization("com.ibm.team.reports.web.ui.internal", "ReportMessages");

(function() {
	
var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
var ReportsClient = com.ibm.team.reports.web.client.internal.ReportsClient;
	
dojo.declare(
	"com.ibm.team.reports.web.app.view.editors.ReportTemplateEditor", 
	[dijit._Widget, dijit._Templated], 
	{
    	templatePath: dojo.moduleUrl("com.ibm.team.reports.web", "ui/internal/templates/ReportTemplateEditor.html"),
		
		constructor: function (props) {
			dojo.mixin(this, props);
			this._uuid = dojox.uuid.generateRandomUuid();
			this.messages = dojo.i18n.getLocalization("com.ibm.team.reports.web.ui.internal", "ReportMessages");
		},
		
		_remoteError: function(error) {
			alert(error.message);
		}
	}
	
);

})();
		
		