/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
	dojo.provide("com.ibm.team.process.web.ui.internal.admin.process_templates.ProcessTemplateManagementPage");//$NON-NLS-1$
	dojo.require("dijit._Widget");//$NON-NLS-1$
	dojo.require("dojo.i18n");//$NON-NLS-1$
	dojo.require("net.jazz.ajax.ui.PlatformUI");//$NON-NLS-1$
	dojo.require("jazz.ui.SideNavigationLayout");//$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.process_templates.ManageTemplates");//$NON-NLS-1$
	dojo.require("com.ibm.team.repository.web.ui.internal.admin.NotAuthorizedView"); //$NON-NLS-1$
	dojo.requireLocalization("com.ibm.team.process.web.ui.internal.admin.process_templates", "Messages");//$NON-NLS-1$ //$NON-NLS-2$
	var ActionRegistry;
	var PlatformUI = net.jazz.ajax.ui.PlatformUI;
	var SideNavigationLayout = jazz.ui.SideNavigationLayout;
	var ManageTemplates = com.ibm.team.process.web.ui.internal.admin.process_templates.ManageTemplates;
	
	var SERVER_PACKAGE = "com.ibm.team.process.web.ui.internal.admin.process_templates."; //$NON-NLS-1$
	var PREFIX = "com.ibm.team.process.";//$NON-NLS-1$
	var ProcessTemplateManagementPageMessages = dojo.i18n.getLocalization("com.ibm.team.process.web.ui.internal.admin.process_templates", "Messages");//$NON-NLS-1$ //$NON-NLS-2$
	var ACTION_SETS = [{
		label: ProcessTemplateManagementPageMessages.ProcessTemplateManagementPage_1,
		actions: [{
			label: ProcessTemplateManagementPageMessages.ProcessTemplateManagementPage_2,
			shortId: "manageTemplates", //$NON-NLS-1$
			widget: "ManageTemplates", //$NON-NLS-1$
			showInNav: true,
			cached: true
		}]
	}];
	
	var ACTION_MAP = {};
	
	function getWorkbench(){
		return PlatformUI.getWorkbench();
	}
	
	dojo.declare("com.ibm.team.process.web.ui.internal.admin.process_templates.ProcessTemplateManagementPage", dijit._Widget, { //$NON-NLS-1$
		constructor: function(){
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.web.ui.internal.admin.process_templates", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
		},
		
		reloadCurrent: function(){
			this._previousActionEntry = this._currentActionEntry || null;
			this._showCurrentWidget(/*isReload*/true);
		},
		
		postCreate: function(){
			this.inherited(arguments);
			
			this._widgetCache = {};
			
			this.domNode.className = "com-ibm-team-repository-admin";//$NON-NLS-1$
			this._appView = new jazz.ui.SideNavigationLayout();
			this.domNode.appendChild(this._appView.domNode);
			
			// register actions and create hyperlinks
			ActionRegistry = getWorkbench().getActionRegistry();
			ActionRegistry.registerAction(PREFIX + "_defaultAction2", this, "_defaultAction2"); //$NON-NLS-1$ //$NON-NLS-2$
			var self = this;
			this.allLinks = [];
			dojo.forEach(ACTION_SETS, function(actionSet){
				self._createNavSection(actionSet);
			});
		},
		
		_createNavSection: function(actionSet){
			var self = this;
			var navSection = this._appView.addNavigationSection(document.createElement("div"), actionSet.label, true); //$NON-NLS-1$
			dojo.forEach(actionSet.actions, function(action){
				var id = PREFIX + action.shortId;
				ACTION_MAP[action.shortId] = action;
				if (action.showInNav) {
					var link = navSection.addSectionRow(action.label, "#action=" + id); //$NON-NLS-1$
					link.__jazzActionId = action.shortId;
					self.allLinks.push(link);
					navSection.addArtifactCommand(link, ProcessTemplateManagementPageMessages.ProcessTemplateManagementPage_3, dojo.hitch(self, self._onNavSectionClick), "admin-refresh-command"); //$NON-NLS-1$
				}
				ActionRegistry.registerAction(id, self, "_handleAction"); //$NON-NLS-1$
			});
		},
		
		_defaultAction2: function(){
			// by default, show the first section from the left-nav
			this._handleAction({
				action: PREFIX + ACTION_SETS[0].actions[0].shortId
			});
		},
		
		_initAdminUI: function(){
			// by default, show the first section from the left-nav
			this._handleAction({
				action: PREFIX + ACTIONS[0].shortId
			});
		},
		
		_handleAction: function(args){
			if (!args.action) {
				return;
			}
			
			// cache the previous entry to see if the widget should be destroyed or
			// not
			this._previousActionEntry = this._currentActionEntry || null;
			
			// parse out the short id from the fully-qualified id
			var shortId = args.action.substring(args.action.lastIndexOf(".") + 1); //$NON-NLS-1$
			this._currentActionEntry = ACTION_MAP[shortId];
			this._currentArgs = args;
			this._currentArgs.parent = this;
			
			// set the title for the action
			getWorkbench().setTitle(this._currentActionEntry.label);
			
			// highlight the selected link and unhighlight the others
			dojo.forEach(this.allLinks, function(link){
				if (link.__jazzActionId === shortId) {
					dojo.toggleClass(link, "selected", true);//$NON-NLS-1$
				} else {
					if (link.aliases != null) {
						var found = false;
						for (var i = 0; i < link.aliases.length; i++) {
							if (link.aliases[i] === shortId) {
								dojo.toggleClass(link, "selected", true); //$NON-NLS-1$
								found = true;
								break;
							}
						}
						if (!found) {
							dojo.toggleClass(link, "selected", false); //$NON-NLS-1$
						}
					} else {
						dojo.toggleClass(link, "selected", false); //$NON-NLS-1$
					}
				}
			});
			
			// call the actual method implementation
			if (!this._currentActionEntry.simpleAction || this._currentContentWidget == null ||
			this._currentContentWidget.id.replace(/_\d+$/, "").replace(/_/g, ".") !== SERVER_PACKAGE + this._currentActionEntry.widget) { //$NON-NLS-1$ //$NON-NLS-2$ 
				this._showCurrentWidget();
			}
			if (this._currentActionEntry.simpleAction) {
				this._currentActionEntry.simpleAction(args, this._currentContentWidget);
			}
		},
		
		_onNavSectionClick: function(e){
			dojo.stopEvent(e);
			this.reloadCurrent();
		},
		
		_showCurrentWidget: function(isReload){
			// save a reference to the prior content widget
			this._previousContentWidget = this._currentContentWidget || null;
			
			if (this._currentActionEntry.cached) {
				this._showCachedWidget(isReload);
			} else {
				this._showUncachedWidget();
			}
			
			// help the garbage collector do its job
			if (this._previousContentWidget && !this._previousActionEntry.cached) {
				this._previousContentWidget.destroyRecursive();
			}
		},
		
		_showCachedWidget: function(isReload){
			var className = this._currentActionEntry.widget;
			if (this._widgetCache[className]) {
				// get widget from the cache if it exists
				this._currentContentWidget = this._widgetCache[className];
			} else {
				// otherwise instantiate it and add it to the cache
				var constructor = dojo.getObject(SERVER_PACKAGE + className);
				this._currentContentWidget = new constructor(this._currentArgs);
				dojo.addClass(this._currentContentWidget.domNode, "com-ibm-team-repository-admin-contentArea"); //$NON-NLS-1$
				this._widgetCache[className] = this._currentContentWidget;
			}
			if (isReload) {
				this._currentContentWidget.reload(this._currentArgs);
			} else {
				this._currentContentWidget.show(this._currentArgs);
				this._appView.setMainContent(this._currentContentWidget.domNode);
			}
		},
		
		_showUncachedWidget: function(){
			var constructor = dojo.getObject(SERVER_PACKAGE + this._currentActionEntry.widget);
			this._currentContentWidget = new constructor(this._currentArgs);
			dojo.addClass(this._currentContentWidget.domNode, "com-ibm-team-repository-admin-contentArea");//$NON-NLS-1$
			this._appView.setMainContent(this._currentContentWidget.domNode);
		}
		
	});
	
	
})();
