﻿/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

class HorizontalBarShape extends BarShape {
	
	public function HorizontalBarShape(outlineColour:Number, fillColour:Number, name:String, value:Number, animate:Boolean) {
		super(outlineColour, fillColour, name, value, animate);
	}	

	public function animateBar(x1:Number, x2:Number, y1:Number, y2:Number):Void {

		this.scale = x1 - x2;
		this.scaleIncrement = Math.abs(this.scale * BarShape.SCALE_RATE);

		var context = this;
        var tweenX2:Number = 0;

	    this.mc.onEnterFrame = function() {
	    	
	    	context.scale = context.scale + context.scaleIncrement;
	        
	        if (context.scale > 0) {
	        	tweenX2 = x2;
	        } else {
	        	tweenX2 = x2 + context.scale;
	        }

	        this.clear();
	        context.drawBar(x1, tweenX2, y1, y2);

	        if (context.scale > 0) {
	        	delete this.onEnterFrame;
	        }
	    };	
	}	
	
	public function destroy():Void {
		super.destroy();
	}			
	
}