/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.dashboard.web.ui.internal.util.ErrorReport");

dojo.require("dojo.i18n"); 

dojo.requireLocalization("com.ibm.team.dashboard.web.ui.internal", "DashboardMessages");

(function() {

var messages = dojo.i18n.getLocalization("com.ibm.team.dashboard.web.ui.internal", "DashboardMessages");

/*
 * A small widget that present an error report with details.
 */
dojo.declare("com.ibm.team.dashboard.web.ui.internal.util.ErrorReport",
	[dijit._Widget, dijit._Templated], {
	
	templatePath: dojo.moduleUrl("com.ibm.team.dashboard.web", "ui/internal/templates/util/ErrorReport.html"),
	
	msg: messages.errorReport,
	
	_expanded: false,
	_messages: messages,
	
	postCreate: function() {
		if (this.error) {
			var html;
			if (typeof(this.error) == "string") {
				html = this.error;
			}
			else {
				html = "";
				if (this.error.name) {
					html = this.error.name + ": ";
				}
				html += this.error.message;
				if (this.error.fileName) {
					html += "<br/>File: " + this.error.fileName;
				}
				if (this.error.lineNumber) {
					html += "<br/>Line: " + this.error.lineNumber;
				}
			}
			this._detailsDiv.innerHTML = html;
			this._detailsLink.style.display = "";
		}
	},
	
	onClick: function(/* Event */ event) {
		dojo.stopEvent(event);
		this._detailsDiv.style.display = this._expanded ? "none" : "";
		this._detailsLink.className = this._expanded ? "collapsed" : "expanded";
		this._detailsLink.innerHTML = this._expanded ? this._messages.errorReportShowDetails : this._messages.errorReportHideDetails;
		this._expanded = !this._expanded;
	}
});
})();
