/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
// declare the Dojo module
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.editor.parts.FrameContainer");

// declare dependencies on other Dojo modules
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

(function() {

dojo.declare("com.ibm.team.workitem.web.ui.internal.view.editor.parts.FrameContainer", [ dijit._Widget, dijit._Templated ], {
	
    remoteLocation: null,
	
    constructor: function(args) {
        if (!args.remoteLocation) throw new Error("Missing 'remoteLocation'");
        if (!dojo.isFunction(args.onData)) throw new Error("Missing 'onData'");
    },
	
    templateString: '<div dojoAttachPoint="_iframeDiv" class="com-ibm-team-foundation-crossdomain-web-IFrameContainer" style="width: 100%; height: 100%;"> </div>',
		
    postCreate: function() {
        var doc = dojo.doc;
        var self= this;
        var returnLocation= new dojo._Url(window.location, dojo.moduleUrl("dojo", "resources/blank.html")).toString();
    
        var frame = doc.createElement(dojo.isIE ? '<iframe name="' + returnLocation + '" onload="window.frameLoadCallback()">' : 'iframe');
        frame.name = returnLocation;
        dojo.style(frame, 'width', '100%');
        dojo.style(frame, 'height', '99%');
        frame.frameBorder = '0';
        frame.marginWidth = '0';
        frame.marginHeight = '0';
        frame.scrolling = 'auto';
    
        var state = 0;
        frame.onload = window.frameLoadCallback = function() {
//     	    console.log("load callback");
            if (!state){
                try {
                    var data= frame.contentWindow.name;
                } catch (e) {
                  // ignore: access exception when trying to access window name
                  return;
                };
                if (typeof data == 'string'){
                    if (data != returnLocation){
                        state = 1; // we are done now
 //                       console.log("data received: " + data) ;
                        self.onData(data);
                    }
                }
            }
        };
        var frameSrc= this.remoteLocation + '#oslc-windowName-1.0';
        frame.src= frameSrc;
         
        this._iframeDiv.appendChild(frame);
    },
		
    __sentinel: null // terminates this class definition
});

})();