/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.view.navigation.PredefinedQuery"); //$NON-NLS-1$

dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$

(function() {

var PlanningUtil= com.ibm.team.apt.web.client.util;

/**
 * Widget to display predefined search links.
 */
dojo.declare("com.ibm.team.apt.web.ui.internal.view.navigation.PredefinedQuery", //$NON-NLS-1$ 
			 [dijit._Widget], {

	// ---- API ------------------------------------------------------------------------------------------------------------

	populate: function (navSection) {
		this.navSection = navSection;
		this._rows = {};
	},

	addQuery: function(queryDescription) {
		var linkHandler = function(event) {
			event.preventDefault();
			location.href= PlanningUtil.getSearchURI(queryDescription, true);
		};
		var sectionRow = this.navSection.addSectionRow(queryDescription.getLabel(), linkHandler, dojo.moduleUrl("com.ibm.team.apt.web", "ui/internal/view/navigation/images/iteration_plan_search.gif")); //$NON-NLS-1$ //$NON-NLS-2$
		this._rows[queryDescription.getPredefinedQueryId()] = sectionRow;
		var sectionRow= null;
	},
	
	getRow: function(queryDescription) {
		if (this._rows[queryDescription.getPredefinedQueryId()])
			return this._rows[queryDescription.getPredefinedQueryId()];
		return null;
	},

	__sentinel: null // terminates this class definition
});
})();