/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.view.plan.dialogs.ErrorDialog"); //$NON-NLS-1$

dojo.require("jazz.ui.Dialog"); //$NON-NLS-1$
dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$

dojo.require("dojo.string"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
	
var bind= dojo.string.substitute;
var MSGS= dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$

dojo.declare("com.ibm.team.apt.web.ui.internal.view.plan.dialogs.ErrorDialog", null, { //$NON-NLS-1$
	
	constructor: function(params){
		var widgetParams = { primaryTitle: params.title };

		var onOk= dojo.hitch(this,function(attributes) {
			this.floatingPane.close();
		});
		
		this.contentWidget= new com.ibm.team.apt.web.ui.internal.view.plan.dialogs.ErrorDialogContent({
			onOk: onOk,  
			description: params.message,
			stacktrace: params.stacktrace
		});
		widgetParams.contentNode = this.contentWidget.domNode;
		this.floatingPane = new jazz.ui.Dialog(widgetParams); 
		this.contentWidget.init();
	}
	
});

dojo.declare("com.ibm.team.apt.web.ui.internal.view.plan.dialogs.ErrorDialogContent", //$NON-NLS-1$
	[dijit._Widget, dijit._Templated], {
	
	templateString: '<div style="padding: 1em 1em 1em 1em;">' + //$NON-NLS-1$
						'<div class="errorMsg" dojoAttachPoint="_domMessage"></div>' + //$NON-NLS-1$
						'<div style="margin-bottom: 0.5em;"><span class="errorDetails collapsed" dojoAttachPoint="_domTwisty"></span><a href="#" dojoAttachPoint="_domShowDetails">' + MSGS.DIALOGS_SERVER_ERROR_DETAILS + '</a></div>' + //$NON-NLS-1$ //$NON-NLS-2$
						'<div class="exclude" style="overflow: scroll; height: 20em; background-color: #FFFFFF; border: 1px solid #CCCCCC;" dojoAttachPoint="_domStacktrace"></div>' + //$NON-NLS-1$
						'<div style="padding: 1em 0em; float: right;">' + //$NON-NLS-1$
							'<button dojoAttachPoint="_okCmd">OK</button>' + //$NON-NLS-1$
						'</div>' + //$NON-NLS-1$
					' </div>', //$NON-NLS-1$
	
	constructor: function(params){
		this._onOk= params.onOk;
		this._description= params.description;
		this._stacktrace= params.stacktrace;
	},
	
	postCreate: function() {
		this.connect(this._okCmd, "onclick", this._onOk); //$NON-NLS-1$
		this.connect(this._domShowDetails, "onclick", this._toggleDetails); //$NON-NLS-1$
		
		this._domMessage.innerHTML= this._description;
		if(this._stacktrace){
			this._domStacktrace.innerHTML= this._stacktrace;
		}
	},
	
	init: function() {
	
	},
	
	_toggleDetails: function(evt){
		dojo.stopEvent(evt);
		dojo.toggleClass(this._domStacktrace, "exclude"); //$NON-NLS-1$
		if(dojo.hasClass(this._domStacktrace, "exclude")){ //$NON-NLS-1$
			dojo.addClass(this._domTwisty, "collapsed"); //$NON-NLS-1$
			dojo.removeClass(this._domTwisty, "expanded"); //$NON-NLS-1$
		} else {
			dojo.addClass(this._domTwisty, "expanded"); //$NON-NLS-1$
			dojo.removeClass(this._domTwisty, "collapsed"); //$NON-NLS-1$
		}
	}
	
});

})();
