/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.viewers.DefaultLabelProvider"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.common.Assert"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.viewers.ColumnLabelProvider"); //$NON-NLS-1$

(function() {
	
var Assert			= com.ibm.team.apt.web.ui.internal.common.Assert;

dojo.declare("com.ibm.team.apt.web.ui.internal.viewers.DefaultLabelProvider", //$NON-NLS-1$
			 [com.ibm.team.apt.web.ui.internal.viewers.ColumnLabelProvider], {

	// ---- api ------------------------------------------------------------------------------------------------------------
	
	getColumn: function(element, index) {
		var result= document.createElement("div"); //$NON-NLS-1$
		
		var icon= this.getIcon(element, index);
		if (icon) {
			var imgContainer= document.createElement("div"); //$NON-NLS-1$
			dojo.addClass(imgContainer, "icon") //$NON-NLS-1$
			
			var img= document.createElement("img"); //$NON-NLS-1$
			img.src= icon;
			
			imgContainer.appendChild(img);
			result.appendChild(imgContainer);
		}
		
		var lable= this.getLabel(element, index);
		var text= document.createElement("span"); //$NON-NLS-1$
		text.appendChild(document.createTextNode(lable));
		result.appendChild(text);
		
		return result;
	},
	
	getLabel: function(element, index) {
		Assert.isTrue(false, "Subclass needs to implement DefaultLabelProvider#getLabel") //$NON-NLS-1$ //$NON-NLS-2$
		return ""; //$NON-NLS-1$
	},
	
	getIcon: function(element, index) {
		Assert.isTrue(false, "Subclass needs to implement DefaultLabelProvider#getIcon") //$NON-NLS-1$ //$NON-NLS-2$
		return null; //$NON-NLS-1$
	},
	
	// ---- implementation -------------------------------------------------------------------------------------------------

	__sentinel: null // terminates this class definition
});

})();
