/*
 * Licensed Materials - Property of IBM
 * Rational ClearQuest 
 * (C) Copyright IBM Corp. 2007, 2009  All Rights Reserved
 * US Government Users Restricted Rights -
 * Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp
 */
 
dojo.provide("com.ibm.rational.cm.web.ui.view.filter.CqFilterDateTextBox");

dojo.require("dijit.form.DateTextBox");
dojo.require("com.ibm.rational.cm.web.ui.view.filter.CqFilterCalendar");


(function(){

var cqCalendar = com.ibm.rational.cm.web.ui.view.filter;
var cq = com.ibm.rational.cm.web;
// bryanh (79425) - The CqFilterCalendar must be pre-loaded in order to pull in needed
// dijit stylesheets
cq.loadModule("com.ibm.rational.cm.web.ui.view.filter.CqFilterCalendar", function(){});

dojo.declare(
	"com.ibm.rational.cm.web.ui.view.filter.CqFilterDateTextBox",
	dijit.form.DateTextBox,
	{	
		/*
			could be used if we use Dojo Markup to classify this widget
		*/
		widgetType: "CqFilterDateTextBox",	
		
		popupClass: "com.ibm.rational.cm.web.ui.view.filter.CqFilterCalendar",
		
		postMixInProperties:function(){
			this.inherited("postMixInProperties", arguments);
			this.constraints.formatLength = "long";
		},
		
		// override the format to recognize the macros
		format: function(/*Date*/ value, /*Object*/ constraints){			
			if(cqCalendar.isDateMacro(value)){
				return value;
			}
			if(!value || value.toString() == this._invalid){ return null; }
			return dojo.date.locale.format(value, constraints);
		},
		
		// override the format to recognize the macros
		isValid: function(/* Boolean*/ isFocused){
			if(cqCalendar.isDateMacro(this.textbox.value)){
				return true;
			}
			return this.inherited("isValid", arguments);
		},
		
		destroy: function(/*Boolean*/ finalize){
			if(this._picker){ this._picker.destroy(); }
			this.inherited('destroy', arguments);
		}
	}
);

// converts to ISO-formatted date in UTC
com.ibm.rational.cm.web.ui.view.filter.toISODate = function(dateArray){
	if(!dateArray){ return []; }
	if(!dojo.isArray(dateArray)){
		dateArray = [dateArray];
	}
	dojo["require"]("dojo.date.stamp");
	var parseDateStr = dojo.date.locale.parse;
	var toISOStr = dojo.date.stamp.toISOString;
	var arr = [];
	dojo.forEach(dateArray, function(value, idx){
		if(cqCalendar.isDateMacro(value)){ // RATLC01258897 : [Yesterday], [Today], [Tomorrow] in Date select dialog of Query Filter couldn't work
			arr[idx] = value;
		}else{
			var d = parseDateStr(value, {
				formatLength: "long",
				selector: "date"
			});
			if(d){
				arr[idx] = toISOStr(d, {
					selector: "date", // RATLC01261781 : greater-than operator is acting as greater-than-or-equal for date fields
					milliseconds: false
				});
			}
		}
	});
	return arr;
}

})();