/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rational.cm.web.workitem.ui.view.record.WorkItemPicker");
dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");
dojo.require("com.ibm.team.workitem.web.ui.internal.module.WorkItemPickerWidget"); // just for loading CSS module for SelectWorkItemContent 
dojo.require("com.ibm.team.workitem.web.ui.internal.view.editor.SelectWorkItemContent");
dojo.require("com.ibm.team.process.web.client.projectarea");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.layout.BorderContainer");
dojo.require("dijit.layout.StackContainer");
dojo.require("dijit.layout.ContentPane");
dojo.require("jazz.ui.RemoteChooserContainer");
dojo.require("jazz.client.xhr");
dojo.requireLocalization("com.ibm.rational.cm.web.workitem.ui", "WorkItemPicker");

(function() {
// constants
var SERVICE_PREFIX   = net.jazz.ajax._contextRoot + "/service/";	 //$NON-NLS-1$
var WORK_ITEM_REST_SERVICE_URI	= "com.ibm.team.workitem.service.internal.roa.IRestService"; //$NON-NLS-1$
var PROCESS_SERVICE_URI = "com.ibm.team.process.internal.common.service.IProcessRestService";
	
// utility objects
var ServiceRequest = com.ibm.team.repository.web.transport.ServiceRequest;
var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
var TeamServerClient = com.ibm.team.repository.web.transport.TeamServerClient;
	
// utility methods
var getCurrentProjectArea = com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;


dojo.declare("com.ibm.rational.cm.web.workitem.ui.view.record.WorkItemPicker", [dijit.layout.BorderContainer, dijit._Templated], {
	widgetsInTemplate: true,
	templatePath: dojo.moduleUrl("com.ibm.rational.cm.web.workitem", "ui/view/record/templates/WorkItemPicker.html"),
	gutters: false,		//  override property of BorderContainer
/* NO_CREATION_DIALOG
	pickerAjaxModuleUrl: net.jazz.ajax._contextRoot + "/_ajax-modules/com.ibm.team.workitem.WIPicker",
	creationAjaxModuleUrl: net.jazz.ajax._contextRoot + "/_ajax-modules/com.ibm.team.workitem.WICreationDialog",
*/
	workItemTypeId: "",
	
	constructor: function(){
		this.messages = dojo.i18n.getLocalization("com.ibm.rational.cm.web.workitem.ui", "WorkItemPicker");
	},
		
	postCreate: function() {
		this.containerNode = this.domNode;

		this.inherited(arguments);
		this.projectArea = getCurrentProjectArea(); 
		
		this._onSelectSelected();
	},
	
	uninitialize: function(){
		this.inherited(arguments);
		this._destroyAllChildren();
	},
	
	_destroyAllChildren: function(){
/* NO_CREATION_DIALOG
		if(this.createContent){
			this.workItemSelectArea.removeChild(this.createContent);
			this.createContent.destroyRecursive();
			delete this.createContent;
		}
*/
		if(this.selectContent){
			this.workItemSelectArea.removeChild(this.selectContent);
			this.selectContent.destroyRecursive();
			delete this.selectContent;
		}
/* NO_CREATION_DIALOG
		if(this._typeSelectionBox){
			this._typeSelectionBox.destroyRecursive();
			delete this._typeSelectionBox;
		}
		if(this._projectSelectionBox){
			this._projectSelectionBox.destroyRecursive();
			delete this._projectSelectionBox;
		}
*/
	},
	
	// Methods to create UI panels 
	_createPanel: function() {
		var args = { 
            onOk: dojo.hitch(this, this.onOk),
            onCancel: dojo.hitch(this, this.onCancel)
		};
		var panel = new com.ibm.team.workitem.web.ui.internal.view.editor.SelectWorkItemContent(args);
		panel.setExclusionList([]);
		return panel;
	},

/* NO_CREATION_DIALOG
	_createPanelWithAjaxModule: function(ajaxModuleUrl, specifyProjectArea) {
		var containerArgs = { 
            remoteLocation: ajaxModuleUrl + "?" +
					"dc:type=" + encodeURIComponent(this.workItemTypeId) + "&" +
					"allowsMultiple=true", 
            onData: dojo.hitch(this, this._onData)
		};
		if(specifyProjectArea){
			containerArgs.remoteLocation += 
				"&projectAreaName=" + encodeURIComponent(this.projectArea.name) +
				"&projectAreaId=" + encodeURIComponent(this.projectArea.itemId);
		}
		if(djConfig.isDebug){
			containerArgs.remoteLocation += "&debug=true"; 
		}
		var container = new jazz.ui.RemoteChooserContainer(containerArgs);
		var iframeNode = container.domNode.lastChild;
		if (iframeNode) {
			iframeNode.scrolling = 'auto';
		}
		return container;
	},
		
	// Handlers for radio buttons for switch "create" or "select"
	_onCreateSelected: function(){
		if(!this.createContent){
			this.createContent = this._createPanelWithAjaxModule(this.creationAjaxModuleUrl, true);
			this.workItemSelectArea.addChild(this.createContent);
		}
		dojo.addClass(this.workItemSelectArea.domNode, "creationContent");
		this.workItemSelectArea.selectChild(this.createContent);
		this._showTypeSelection(true);
		this.createWI.checked = true;
	},
*/
	_onSelectSelected: function(){
		if(!this.selectContent){
//			this.selectContent = this._createPanelWithAjaxModule(this.pickerAjaxModuleUrl, true);
			this.selectContent = this._createPanel();
			this.workItemSelectArea.addChild(this.selectContent);
		}
		dojo.removeClass(this.workItemSelectArea.domNode, "creationContent");
		this.workItemSelectArea.selectChild(this.selectContent);
/*	NO_CREATION_DIALOG
		this._showTypeSelection(false);
		this.selectWI.checked = true;
*/
	},
/*	NO_CREATION_DIALOG
	// work item type selection for create new work item
	_showTypeSelection: function(show){
		if(show){
			if(!this._projectSelectionBox){
				var args = {
					messages: this.messages,
					currentProjectArea: this.projectArea
				};
				this._projectSelectionBox = new com.ibm.rational.cm.web.workitem.ui.view.record.ProjectAreaSelection(args);
				this.connect(this._projectSelectionBox, "projectChanged", this._projectChanged);
			}
			if(!this._typeSelectionBox){
				var args = {
					messages: this.messages,
					currentProjectArea: this.projectArea
				};
				this._typeSelectionBox = new com.ibm.rational.cm.web.workitem.ui.view.record.TypeSelection(args);
				this.connect(this._typeSelectionBox, "typeChanged", this._typeChanged);
			}
			this.top.domNode.appendChild(this._projectSelectionBox.domNode);
			this.top.domNode.appendChild(this._typeSelectionBox.domNode);
		} else {
			if (this._projectSelectionBox) {
				this.top.domNode.removeChild(this._projectSelectionBox.domNode);
			}
			if (this._typeSelectionBox){
				this.top.domNode.removeChild(this._typeSelectionBox.domNode);
			}
		}
		this.contentArea.layout();
	},
	
	_typeChanged: function(workItemType){
		this.workItemTypeId = workItemType.id;
		if(this.createContent){
			this.workItemSelectArea.removeChild(this.createContent);
			this.createContent.destroyRecursive();
			delete this.createContent;
		}
		if(!this.selectWI.checked){
			this._onCreateSelected();
		}
	},

	_projectChanged: function(projectArea){
		this.projectArea = projectArea;
		if(this._typeSelectionBox){
			this.top.domNode.removeChild(this._typeSelectionBox.domNode);
			this._typeSelectionBox.destroyRecursive();
			delete this._typeSelectionBox;
		}
		this._typeChanged("");
	},
*/	
	
	// OK button handler
	_onData: function(data) {
	    if (data.length != 0) {
	        var newItems= dojo.fromJson(data);
	        this.onOk(newItems);
	    } else {
	        this.onCancel();
		}
	},
	
	// Application should connect or override the following event handlers
	onOk: function(items){
	},
	
	onCancel: function(){
	}
});

/* NO_CREATION_DIALOG
dojo.declare("com.ibm.rational.cm.web.workitem.ui.view.record.TypeSelection", [dijit._Widget, dijit._Templated], {
	widgetsInTemplate: true,
	templateString: '<div>' + 
					'<table class="nameValuePairForm">' +
					'<tr><td nowrap style="width: 7em">${messages.workItemType}</td>' +
					'<td><select dojoAttachPoint="typeSelectionBox" dojoAttachEvent="onchange:_typeChanged" style="min-width: 14em"></select></td>' +
					'</tr></table></div>',
	//
	postCreate: function(){
		this.inherited(arguments);
		this._getAllTypes();
	},

	_getAllTypes: function(){
		var select = this.typeSelectionBox;
		select.length = 0; // clear all
		jazz.client.xhrGet({
			url: SERVICE_PREFIX + WORK_ITEM_REST_SERVICE_URI + "/types/" + this.currentProjectArea.itemId,
			handleAs: "json",
			headers: {"Accept": "text/json"},
			load: function(data){
				dojo.forEach(data.collection, function(item){
					var type = item.type;
					select[select.length] = new Option(type.name.value, type.identifier.value);
				});
			}
		});
   	},
		
	_typeChanged: function(e){
		var selectElement = this.typeSelectionBox;
		var selectedItem = selectElement[selectElement.selectedIndex];
		this.typeChanged({name:selectedItem.text, id:selectedItem.value});
	},
	
	typeChanged: function(workItemType){
	}
});

dojo.declare("com.ibm.rational.cm.web.workitem.ui.view.record.ProjectAreaSelection", [dijit._Widget, dijit._Templated], {
	widgetsInTemplate: true,
	templateString: '<div>' + 
					'<table class="nameValuePairForm">' +
					'<tr><td nowrap style="width: 7em">${messages.projectArea}</td>' +
					'<td><select dojoAttachPoint="projectAreaSelectionBox" dojoAttachEvent="onchange:_projectChanged" style="min-width: 14em"></select></td>' +
					'</tr></table></div>',
	//
	postCreate: function(){
		this.inherited(arguments);
		this._getAllProjectAreas();
	},
	
	_getAllProjectAreas: function(){
		var select = this.projectAreaSelectionBox;
		select.length = 0; // clear all
		var srh = new ServiceResponseHandler(this, "_onAllProjectArea", "_noProjectArea");
		var serviceRequest = new ServiceRequest(PROCESS_SERVICE_URI, "getAllProjectAreas", {hideArchivedProjects: true});
		TeamServerClient.invokeService(serviceRequest, srh);
   	},
	
	// Callback for REST call to get all project areas
	_onAllProjectArea: function(projectAreas){
		var select = this.projectAreaSelectionBox;
		for(var i=0; i<projectAreas.length; i++){
			var p = projectAreas[i];
			select[i] = new Option(p.name, p.itemId);
			if(p.name === this.currentProjectArea.name){
				select.selectedIndex = i;
			}
		}
	},
	
	_noProjectArea: function(){
	},
	
	_projectChanged: function(e){
		var selectElement = this.projectAreaSelectionBox;
		var selectedItem = selectElement[selectElement.selectedIndex];
		this.currentProjectArea = {name:selectedItem.text, itemId:selectedItem.value};
		this.projectChanged(this.currentProjectArea);
	},
	
	projectChanged: function(projectArea){
	}
});
*/

})();