/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.client.OutOfOfficeItem"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.client.PlanElement"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.client.internal.Instant"); //$NON-NLS-1$

(function() {

var PlanElement						= com.ibm.team.apt.client.PlanElement;
var Instant							= com.ibm.team.apt.client.internal.Instant;

dojo.declare("com.ibm.team.apt.client.OutOfOfficeItem", PlanElement, { //$NON-NLS-1$

	__absence: null,
	__plan: null,
	__owner: null,
	
	constructor: function(plan, absence, owner) {
		this.__plan= plan;
		this.__absence= absence;
		this.__owner= owner;
		
		this.__start= absence.startDate;
		this.__end= absence.endDate;
	},

	equals: function(other) {
		if (this === other)
			return true;

		if (this.declaredClass !== other.declaredClass)
			return false;

		return this.__absence.itemId === other.__absence.itemId;
	},

	// ---- api ------------------------------------------------------------------------------------------------------------

	getUuid: function() {
		return this.__absence.itemId;
	},
	
	getElementKey: function() {
		return this.__absence.itemId;
	},

	// ---- implementation -------------------------------------------------------------------------------------------------

	getSummary: function() {
		return this.__absence.label;
	},

	getIconUrl: function() {
		return this.__absence.iconURL;
	},

	getStart: function() {
		return this.__start;
	},
	
	getEnd: function() {
		return this.__end;
	},
	
	getOwner: function() {
		return this.__owner;
	},
	
	isResolved: function() {
		return this.__end.before(this.__plan.getReferenceTime());
	},

	getScheduledTime: function() {
		var sequenceManager= this._getSequenceManager();
		return sequenceManager != null ? sequenceManager._getScheduledTime(this) : null;
	},

	isAuxiliaryPlanItem: function() {
		return false; 
	},
	
	isPrimaryPlanItem: function() {
		return true;
	},
	
	getPlanModel: function() {
		return this.__plan;
	},
	
	getParent: function() {
		return this.__plan;
	},
	
	// ---- implementation -------------------------------------------------------------------------------------------------
	
	_getSequenceManager: function() {
		return this.__plan.getItemSequenceManager(this.getOwner());
	},

	__sentinel: null // terminates this class definition
});

})();
