/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.ui.model._ViewerUpdater"); //$NON-NLS-1$

( function() {

com.ibm.team.apt.ui.model._ViewerUpdater.getRefreshRunnable= function(viewer) {
	return function() {
		viewer.refresh();
		return undefined; // get rid of stupid JSDT error
	};
};

com.ibm.team.apt.ui.model._ViewerUpdater.getAddEntryRunnable= function(viewer, entry) {
	return function() {
		var parentEntry= entry._getParent();
		viewer.add(parentEntry, entry);
		entry._processUpdate();
		// TODO restore stored expansion state (if any)
		return undefined; // get rid of stupid JSDT error
	};
};

com.ibm.team.apt.ui.model._ViewerUpdater.getRefreshEntryRunnable= function(viewer, entry) {
	return function() {
		viewer.refresh(entry);
		entry._processUpdate();
		return undefined; // get rid of stupid JSDT error
	};
};

com.ibm.team.apt.ui.model._ViewerUpdater.getRemoveEntryRunnable= function(viewer, entry, saveState) {
	return function() {
		viewer.remove(entry);
		entry._processUpdate();
		// TODO save expansion state to entry if saveState
		return undefined; // get rid of stupid JSDT error
	};
};

com.ibm.team.apt.ui.model._ViewerUpdater.getResortEntryRunnable= function(viewer, entry) {
	return function() {
		viewer.resort(entry);
		entry._processUpdate();
		return undefined; // get rid of stupid JSDT error
	};
};

com.ibm.team.apt.ui.model._ViewerUpdater.getUpdateEntryRunnable= function(viewer, entry, properties) {
	return function() {
		viewer.update(entry);
		entry._processUpdate();
		return undefined; // get rid of stupid JSDT error
	};
};

})();
